{###############################################################################
# Dipesh-AutoRun-32 V2
################################################################################
# Programmiert & Entwickelt von Sebastian Sauer (Dipesh)                       #
# in Borland/Inprise Delphi 3                                                  #
###############################################################################}

UNIT Change;

INTERFACE

Uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     StdCtrls, ExtCtrls, FileCtrl;

Type
  TChangeForm = class(TForm)
    FileListBox: TFileListBox;
    DirectoryListBox: TDirectoryListBox;
    DriveComboBox: TDriveComboBox;
    FilterComboBox: TFilterComboBox;
    ButtonUebernehmen: TButton;
    ButtonAbbrechen: TButton;
    EditCom: TComboBox;
    procedure OnChange(Sender: TObject);
    procedure EditCom_OnChange(Sender: TObject);
    procedure ButtonUebernehmen_OnClick(Sender: TObject);
  end;

Var ChangeForm: TChangeForm;

IMPLEMENTATION

uses Edit;

{$R *.DFM}

procedure TChangeForm.OnChange(Sender: TObject);
var s1: string;
begin
  If ActiveControl<>EditCom then begin
    If FileExists(FileListBox.Filename) then s1:=FileListBox.Filename else s1:=DirectoryListBox.Directory;
    If LowerCase(s1)<>LowerCase(Trim(EditCom.Text)) then EditCom.Text:=LowerCase(s1);
  end;
end;

procedure TChangeForm.EditCom_OnChange(Sender: TObject);
begin
  If ActiveControl=EditCom then begin
    If FileExists(EditCom.Text) then begin
      If LowerCase(EditCom.Text)<>LowerCase(FileListBox.FileName) then FileListBox.FileName:=EditCom.Text;
    end else
    If DirectoryExists(EditCom.Text) then begin FileListBox.ItemIndex:=-1;
      If LowerCase(EditCom.Text)<>LowerCase(FileListBox.FileName) then FileListBox.FileName:=EditCom.Text;
    end;
  end;
end;

procedure TChangeForm.ButtonUebernehmen_OnClick(Sender: TObject);
begin
  If Trim(EditCom.Text)='' then begin
    If MessageBox(0,'Es wurde keine Befehlszeile angegeben.','Auswahl wirklich bernehmen ?',MB_IconQuestion+MB_OkCancel+MB_SetForeground+MB_ApplModal)<>idOk then Exit;
  end else If UpCase(EditCom.Text[1])<>UpCase(ParamStr(0)[1]) then
    If MessageBox(0,'Die angegebene Befehlszeile befindet sich nicht auf dem selben Laufwerk'+#13+
                    'wie Autorun.exe und kann deshalb nicht zu einer laufwerksunabhngigen'+#13+
                    'Angabe verkrzt werden.','Auswahl wirklich bernehmen ?',MB_IconQuestion+MB_OkCancel+MB_SetForeground+MB_ApplModal)<>idOk then Exit;
  Try ChangeDropDownItems.Add(Trim(EditCom.Text)); Finally ModalResult:=mrOk; end;
end;

END.
