{###############################################################################
# Dipesh-AutoRun-32 V2
################################################################################
# Programmiert & Entwickelt von Sebastian Sauer (Dipesh)                       #
# in Borland/Inprise Delphi 3                                                  #
###############################################################################}

UNIT Main;

INTERFACE

Uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     StdCtrls, ExtCtrls, ComCtrls, FileCtrl, Buttons, ShellApi;

Const IniFileCom: string                      = 'Autorun.ini'; // Dateiname der Ini-Datei, keine Verzeichnisangaben
      IniFileCom_Pruefstring                  = '<Dipesh-Autorun-32 V2 Ini-Datei>'; // Prfstring der Ini-Dateien, anhand dieses Strings werden die Ini-Dateien als gltig identifiziert.
      SingleInstance: boolean                 = true; // nur eine Instanz zulassen
      MainWidth: integer                      = 445; // Vorgegebene Fensterbreite
      MainHeight: integer                     = 325; // Vorgegebene Fensterbreite
      MainShowMaximized: boolean              = false; // Vorgabewerte ob Hauptfenster beim start maximiert werden soll
      ShowOpenDialogOnStart: boolean          = false; // Dateiauswahlfenster beim start zeigen
      ShowEditFormOnStart: boolean            = false; // Bearbeitenfenster beim Start aufrufen
      ShowIcons: integer                      = 0; // Icons anzeigen; 1=Kleine 2=Groe else Keine(default)
      ViewStyle: integer                      = 0; // 1=Liste, 2=Details else Buttons(default)
      BtnLeft: integer                        = 6; // Linker/Rechter Rand
      BtnTop: integer                         = 6; // Oberer Rand
      BtnHeight: integer                      = 21; // Hhe der Buttons
      BtnDistance: integer                    = 3; // Distanz zwischen den Buttons
      BtnIconsDistance: integer               = 5; // Distanz zwischen Icons und Text der Buttons
      BtnIconsLayout: integer                 = 0; // 1=blGlyphRight 2=blGlyphTop 3=blGlyphBottom else blGlyphLeft(default)
      ShowHotTrack: boolean                   = false; // Gilt sowohl fr Buttons als auch fr die Liste
      ListColumnwidthName: integer            = 250; // Vorgegebene Spaltenbreite der Spalte "Name"
      ListColumnwidthBefehl: integer          = 320; // Vorgegebene Spaltenbreite der Spalte "Befehl"
      ListShowHeader: boolean                 = true; // Tabellenkopf zeigen
      ListGridLines: boolean                  = false; // GridLines zeigen
      ListWrapText: boolean                   = false; // Text umbrechen
      ExecuteOnStart: string                  = ''; // Diesen String beim Start ausfhren
      ExecuteOnStart_ShowState: integer       = 0; // 1=SW_MAXIMIZE 2=SW_MINIMIZE 3=SW_SHOW 4=SW_SHOWDEFAULT 5=SW_SHOWMAXIMIZED 6=SW_SHOWMINIMIZED 7=SW_SHOWMINNOACTIVE 8=SW_SHOWNA 9=SW_SHOWNOACTIVATE else SW_SHOWNORMAL(default)
      ExecuteOnStart_ExitAutorun: boolean     = false; // Nach ausfhren Autorun beenden
      ExecuteOnExit: string                   = ''; // Beim beenden diesen String ausfhren
      ExecuteOnExit_ShowState: integer        = 0; // 1=SW_MAXIMIZE 2=SW_MINIMIZE 3=SW_SHOW 4=SW_SHOWDEFAULT 5=SW_SHOWMAXIMIZED 6=SW_SHOWMINIMIZED 7=SW_SHOWMINNOACTIVE 8=SW_SHOWNA 9=SW_SHOWNOACTIVATE else SW_SHOWNORMAL(default)
      PlaySoundOnStart: integer               = 0; // 1=MB_OK 2=MB_ICONASTERISK 3=MB_ICONEXCLAMATION 4=MB_ICONQUESTION 5=MB_ICONHAND
      KommentarTextDatei: string              = ''; // Dateiname der Kommentardatei die in TMainForm.Memo angezeigt werden soll
      KommentarFeldHight: integer             = -1; // Hhe des Kommentarfeldes (TMemo.Height)
      Statusbar_Show: boolean                 = false; // Statusbar anzeigen
      Statusbar_Alignment: integer            = 0; // 1=Zentriert, 2=Rechts, ansonsten Links (default)
      HideIfReadOnly: integer                 = 0; // 1=Button "Bearbeiten" verstecken, 2=ButtonPanel verstecken, ansonsten nichts verstecken (default)
      AfterExecute: integer                   = 0; // 1,2=Minimieren (wenn 3 dann "Bei schlieen des ausgefhrten Programmes Autorun wiederherstellen") 3,4=Beenden (wenn 4 dann "Nochmals rckfragen ob Autorun wirklich beendet werden soll") else Nichts(default)
      SelectedItem: integer                   = -1; // Achtung: Diesen Wert nicht verndern !!!

Type
  TExtBitBtn = class(TBitBtn) // Damit unsere Buttons die netten HotTracks haben
    protected
      procedure CMMouseEnter(var Msg: TMessage); message CM_MOUSEENTER;
      procedure CMMouseLeave(var Msg: TMessage); message CM_MOUSELEAVE;
  end;
  TMainForm = class(TForm) // das Hauptforumlar
    ButtonPanel: TPanel;
    ButtonBeenden: TBitBtn;
    ImageList: TImageList;
    Panel1: TPanel;
    MainPanel: TPanel;
    StatusbarMain: TPanel;
    Statusbar: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    OpenDialog: TOpenDialog;
    Memo: TMemo;
    Splitter: TSplitter;
    ButtonBearbeiten: TButton;
    // Formular
    procedure OnClose(Sender: TObject; var Action: TCloseAction);
    procedure OnCreate(Sender: TObject);
    procedure OnShow(Sender: TObject);
    procedure OnActivate(Sender: TObject);
    // OnResize
    procedure MainPanel_OnResize(Sender: TObject);
    procedure ButtonPanel_OnResize(Sender: TObject);
    // OnClick
    procedure ButtonBearbeiten_OnClick(Sender: TObject);
    procedure ButtonBeenden_OnClick(Sender: TObject);
  public
    // Public
    function FileIsReadOnly(FileCom: string): boolean;
    procedure SetViewStyle(ViewStyleNr: integer);
    procedure SetItems;
    procedure SetKommentarMemo;
    procedure SetStatusbarShowState;
    function ExpandFileCom(var FileCom: string; var Parameter: string): integer;
    procedure ExecuteCom(ExecuteStr: string; ShowState: integer; UseAfterExecute, ShowErrorMsg: boolean);
  private
    // Private
    AppTitle: string;
    procedure AppMessage(var Msg: TMsg; var Erledigt: Boolean);
    procedure WMSysCommand(var Message: TMessage); message WM_SYSCOMMAND;
    procedure ZoomMinimized;
    procedure ZoomRestore;
    procedure ShowHints(Sender: TObject);
  end;

Var IsMinimized: boolean;
    WinDir: string;
    ItemLst: TStringList;
    MainForm: TMainForm;

function BoolToInteger(BoolWert: boolean): integer;

IMPLEMENTATION

Uses Edit, Button, List;

{$R *.DFM}

procedure TExtBitBtn.CMMouseEnter(var Msg: TMessage);
begin If ShowHotTrack then begin Font.Color:=clBlue; Update; end; end;

procedure TExtBitBtn.CMMouseLeave(var Msg: TMessage);
begin If ShowHotTrack then begin Font.Color:=clWindowText; Update; end; end;

{-------------------------------------------------------------------------------
Formular
-------------------------------------------------------------------------------}

procedure TMainForm.OnClose(Sender: TObject; var Action: TCloseAction);
var i1: integer;
begin
  ItemLst.Free;
  If Trim(ExecuteOnExit)>'' then begin Case ExecuteOnExit_ShowState of 1: i1:=SW_MAXIMIZE; 2: i1:=SW_MINIMIZE; 3: i1:=SW_SHOW; 4: i1:=SW_SHOWDEFAULT;
      5: i1:=SW_SHOWMAXIMIZED; 6: i1:=SW_SHOWMINIMIZED; 7: i1:=SW_SHOWMINNOACTIVE; 8: i1:=SW_SHOWNA; 9: i1:=SW_SHOWNOACTIVATE; else i1:=SW_SHOWNORMAL; end;
    ExecuteCom(ExecuteOnExit,i1,false,false);
  end;
end;

procedure TMainForm.OnCreate(Sender: TObject);
var b1, b2: boolean; i1, i2: integer; s1, s2: string; file1: textfile; strlst1: Tstringlist;
  // Erweitert eine angegebene Ini-Datei zu einer vollstndige Verzeichnis+Dateinamensangabe und liefert folgende Werte zurck (Result):
  // 0 = Erfolgreich: Datei gefunden und sie ist eine gltige Ini-Datei !
  // 1 = Fehler: Datei nicht gefunden
  // 2 = Fehler: Datei gefunden, aber diese ist keine gltige Autorun Ini-Datei (Prfstring nicht gefunden)
  function ExpandIniFile(var FileStr: string): integer;
  var eif_b1: boolean; eif_s1, eif_s2: string; eif_file1: textfile;
  begin
    If FileExists(FileStr) then FileStr:=ExpandFileName(FileStr) else
    If FileExists(ExtractFilePath(ParamStr(0))+FileStr) then FileStr:=ExtractFilePath(ParamStr(0))+FileStr else
    If FileExists(ParamStr(0)[1]+':\'+FileStr) then FileStr:=ParamStr(0)[1]+':\'+FileStr else begin Result:=1; Exit; end;
    Result:=2;
    Try AssignFile(eif_file1,FileStr); {$I-} Reset(eif_file1); {$I+}
      If IoResult=0 then begin eif_s1:=LowerCase(Trim(IniFileCom_Pruefstring)); eif_b1:=false;
        Repeat If Eof(eif_file1) then eif_b1:=true else begin ReadLn(eif_file1,eif_s2); If LowerCase(Trim(eif_s2))=eif_s1 then begin Result:=0; eif_b1:=true; end; end; until eif_b1; end;
    Finally {$I-} CloseFile(eif_file1); {$I+} end;
  end;
  // Ggf. wird, wenn vorhanden, die andere Autorun-Instanz aktiviert und diese hier beendet
  function AndereInstanzAktivieren: boolean;
  var aia_pc1: pchar; aia_Sem: THandle; aia_Wind: HWnd;
  begin
    aia_Sem:=CreateSemaphore(nil,0,1,'Dipesh-Autorun-32 V2 - Semaphore'); Result:=(aia_Sem<>0)and(GetLastError=ERROR_ALREADY_EXISTS);
    If Result then begin CloseHandle(aia_Sem); aia_pc1:=PChar(Application.Title); Application.Title:='Dipesh-Autorun-32 V2 - Wait...'; aia_Wind:=FindWindow(nil,aia_pc1);
      If aia_Wind<>0 then begin PostMessage(aia_Wind,WM_SYSCOMMAND,SC_RESTORE,0); SetForegroundWindow(aia_Wind); end; end;
  end;
begin
  Screen.Cursor:=crHourGlass; AppTitle:=Application.Title; Application.OnMessage:=AppMessage; IsMinimized:=false;
  // Kommandozeilenparameter auswerten
  If ParamCount>0 then begin s1:=''; For i1:=1 to ParamCount do s1:=s1+' '+ParamStr(i1); s1:=Trim(s1); b1:=false;
    Repeat
      If Length(s1)>0 then begin
        If s1[1]='/' then begin
          If Length(s1)>1 then Case UpCase(s1[2]) of
            'O': ShowOpenDialogOnStart:=true; {/o = OpenDialog auf jeden Fall zeigen}
            'P': HideIfReadOnly:=99; {/p = Auf jeden Fall ButtonPanel anzeigen}
            'E': ShowEditFormOnStart:=true; {/e = Nach start TEditForm anzeigen}
          end;
          i1:=Pos(' ',s1); If i1>0 then begin Delete(s1,1,i1); s1:=Trim(s1); end else b1:=true;
        end else begin {Nachprfen ob eventuell Datei-/Verzeichnisname der Ini-Datei angegeben wurde}
          i1:=Pos(' /',s1); If i1=0 then i1:=Length(s1); s2:=Trim(copy(s1,1,i1));
          Repeat
            If ExpandIniFile(s2)=0 then begin i2:=1; IniFileCom:=s2; end else begin i2:=0;
              Repeat b2:=true; If Length(s2)<1 then i2:=2 else If s2[Length(s2)]<>' ' then begin b2:=false; Delete(s2,Length(s2),1); end else s2:=Trim(s2); until b2;
            end;
          until i2>0;
          i2:=Pos(' ',s1); If i2=0 then i2:=Length(s1); Delete(s1,1,i2); s1:=Trim(s1);
        end;
      end else b1:=true;
    until b1;
  end;
  // Ini-Datei ermitteln
  Repeat
    b1:=false;
    b2:=ShowOpenDialogOnStart;
    If not b2 then begin
      Case ExpandIniFile(IniFileCom) of 0: b1:=true;
        1: s1:='Die Ini-Datei '+UpperCase(IniFileCom)+' konnte nicht gefunden werden.';
        2: s1:='Die Datei '+UpperCase(IniFileCom)+#13+'ist keine gltige Dipesh-Autorun-32 Ini-Datei.';
      end;
      If not b1 then Case MessageBox(0,PChar(s1+#13+'Wollen Sie eine bereits vorhandene Ini-Datei auswhlen ?'),'Frage: Ini-Datei...',MB_IconQuestion+MB_YesNoCancel+MB_SetForeground+MB_ApplModal) of
        idNo: begin IniFileCom:=''; b1:=true; end; idCancel: Try Free; Finally Halt; end; end;
    end;
    If (b2)or(not b1) then With OpenDialog do begin b2:=false;
      If FileExists(IniFileCom) then begin InitialDir:=ExtractFilePath(ExpandFileName(IniFileCom));
        Filename:=LowerCase(ExtractFileName(IniFileCom)); end else InitialDir:=ExtractFilePath(ParamStr(0));
      If Execute then IniFileCom:=Filename;
    end;
  until b1;
  // Nun gehts ans einlesen der Ini-Datei
  ItemLst:=TStringList.Create;
  If FileExists(IniFileCom) then begin AssignFile(file1,IniFileCom); {$I-} Reset(file1); {$I+}
    If IoResult=0 then begin strlst1:=TStringList.Create; Try i1:=0;
      // Zunchst smtliche relevanten Zeilen der Ini-Datei einlesen
      While not Eof(file1) do begin ReadLn(file1,s1); If s1>'' then If s1[1]<>'/' then begin
        If LowerCase(Trim(s1))='[main]' then i1:=1 else If LowerCase(Trim(s1))='[items]' then i1:=2 else
        Case i1 of 1: strlst1.Add(Trim(s1)); 2: ItemLst.Add(Trim(s1)); end;
      end; end;
      // Nun noch [main] entspr. umsetzen (strlst1), bei [Items] geschieht dies spter durch die procedure SetItems (ItemLst)
      s1:=strlst1.Values['Title']; If s1>'' then begin If LowerCase(s1)=LowerCase(Application.Title) then s1:=s1+' '; Caption:=s1; end;
      s1:=strlst1.Values['SingleInstance']; If s1>'' then SingleInstance:=Trim(s1)<>'0';
      s1:=strlst1.Values['Width']; If s1>'' then begin Val(Trim(s1),i1,i2); If i2=0 then MainWidth:=i1; end; Width:=MainWidth;
      s1:=strlst1.Values['Height']; If s1>'' then begin Val(Trim(s1),i1,i2); If i2=0 then MainHeight:=i1; end; Height:=MainHeight;
      s1:=strlst1.Values['ShowMaximized']; If s1>'' then MainShowMaximized:=Trim(s1)='1';
      s1:=strlst1.Values['HotTrack']; If s1>'' then ShowHotTrack:=s1<>'0';
      s1:=strlst1.Values['ShowIcons']; If s1>'' then begin Val(Trim(s1),i1,i2); If i2=0 then ShowIcons:=i1; end;
      s1:=strlst1.Values['ViewStyle']; If s1>'' then begin Val(Trim(s1),i1,i2); If i2=0 then ViewStyle:=i1; end;
      s1:=strlst1.Values['ExecuteOnStart']; If Trim(s1)>'' then ExecuteOnStart:=s1;
      s1:=strlst1.Values['ExecuteOnStart ShowState']; If s1>'' then begin Val(Trim(s1),i1,i2); If i2=0 then ExecuteOnStart_ShowState:=i1; end;
      s1:=strlst1.Values['ExecuteOnStart ExitAutorun']; If s1>'' then ExecuteOnStart_ExitAutorun:=Trim(s1)='1';
      s1:=strlst1.Values['ExecuteOnExit']; If Trim(s1)>'' then ExecuteOnExit:=s1;
      s1:=strlst1.Values['ExecuteOnExit ShowState']; If s1>'' then begin Val(Trim(s1),i1,i2); If i2=0 then ExecuteOnExit_ShowState:=i1; end;
      s1:=strlst1.Values['PlaySoundOnStart']; If s1>'' then begin Val(Trim(s1),i1,i2); If i2=0 then PlaySoundOnStart:=i1; end;
      s1:=strlst1.Values['Comment Textfile']; If s1>'' then KommentarTextDatei:=s1;
      s1:=strlst1.Values['Comment Height']; If s1>'' then begin Val(Trim(s1),i1,i2); If i2=0 then KommentarFeldHight:=i1; end;
      s1:=strlst1.Values['Statusbar Show']; If Trim(s1)>'' then Statusbar_Show:=s1<>'0';
      s1:=strlst1.Values['Statusbar Alignment']; If s1>'' then begin Val(Trim(s1),i1,i2); If i2=0 then If (i1>=0)and(i1<=2) then Statusbar_Alignment:=i1; end;
      If HideIfReadOnly<>99 then s1:=strlst1.Values['HideIfReadOnly']; If s1>'' then begin Val(Trim(s1),i1,i2); If i2=0 then HideIfReadOnly:=i1; end;
      s1:=strlst1.Values['AfterExecute']; If s1>'' then begin Val(Trim(s1),i1,i2); If i2=0 then AfterExecute:=i1; end;
      s1:=strlst1.Values['Buttons Left']; If s1>'' then begin Val(Trim(s1),i1,i2); If i2=0 then BtnLeft:=i1; end;
      s1:=strlst1.Values['Buttons Top']; If s1>'' then begin Val(Trim(s1),i1,i2); If i2=0 then BtnTop:=i1; end;
      s1:=strlst1.Values['Buttons Height']; If s1>'' then begin Val(Trim(s1),i1,i2); If i2=0 then BtnHeight:=i1; end;
      s1:=strlst1.Values['Buttons Distance']; If s1>'' then begin Val(Trim(s1),i1,i2); If i2=0 then BtnDistance:=i1; end;
      s1:=strlst1.Values['Buttons Spacing']; If s1>'' then begin Val(Trim(s1),i1,i2); If i2=0 then BtnIconsDistance:=i1; end;
      s1:=strlst1.Values['Buttons Layout']; If s1>'' then begin Val(Trim(s1),i1,i2); If i2=0 then BtnIconsLayout:=i1; end;
      s1:=strlst1.Values['List Columnwidth Name']; If s1>'' then begin Val(Trim(s1),i1,i2); If i2=0 then ListColumnwidthName:=i1; end;
      s1:=strlst1.Values['List Columnwidth Befehl']; If s1>'' then begin Val(Trim(s1),i1,i2); If i2=0 then ListColumnwidthBefehl:=i1; end;
      s1:=strlst1.Values['List ShowHeader']; If s1>'' then ListShowHeader:=s1<>'0';
      s1:=strlst1.Values['List GridLines']; If s1>'' then ListGridLines:=s1='1';
      s1:=strlst1.Values['List WrapText']; If s1>'' then ListWrapText:=s1='1';
      s1:=strlst1.Values['SelectedItem']; If s1>'' then begin Val(Trim(s1),i1,i2); If i2=0 then SelectedItem:=i1; end;
    Finally strlst1.Free; end; end;
    {$I-} CloseFile(file1); {$I+}
  end;
  // Werte umsetzen und weitere Vorbereitungen
  If SingleInstance then If AndereInstanzAktivieren then Try Free; Finally Halt; end;
  If Trim(ExecuteOnStart)>'' then begin Case ExecuteOnStart_ShowState of 1: i1:=SW_MAXIMIZE; 2: i1:=SW_MINIMIZE; 3: i1:=SW_SHOW; 4: i1:=SW_SHOWDEFAULT;
      5: i1:=SW_SHOWMAXIMIZED; 6: i1:=SW_SHOWMINIMIZED; 7: i1:=SW_SHOWMINNOACTIVE; 8: i1:=SW_SHOWNA; 9: i1:=SW_SHOWNOACTIVATE; else i1:=SW_SHOWNORMAL; end;
    ExecuteCom(ExecuteOnStart,i1,false,false); If ExecuteOnStart_ExitAutorun then Try Free; Finally Halt; end;
  end;
  SetStatusbarShowState; // Ggf. Statuspanel vorbereiten und anzeigen
  Case HideIfReadOnly of 1: ButtonBearbeiten.Visible:=not FileIsReadOnly(IniFileCom); 2: ButtonPanel.Visible:=not FileIsReadOnly(IniFileCom); end;
  SetLength(WinDir,MAX_PATH); SetLength(WinDir,GetWindowsDirectory(PChar(WinDir),MAX_PATH)); If WinDir[Length(WinDir)]<>'\' then WinDir:=WinDir+'\';
end;

procedure TMainForm.OnShow(Sender: TObject);
begin SetViewStyle(ViewStyle); MainPanel_OnResize(Sender); end;

procedure TMainForm.OnActivate(Sender: TObject);
begin
  If Tag=0 then begin // Beim Start (erstmaliges OnActivate) soll dieses gemacht werden
    Tag:=1; If MainShowMaximized then WindowState:=wsMaximized; Update; SetItems;
    SetKommentarMemo;
    Case PlaySoundOnStart of 1: MessageBeep(MB_OK); 2: MessageBeep(MB_ICONASTERISK); 3: MessageBeep(MB_ICONEXCLAMATION);
      4: MessageBeep(MB_ICONQUESTION); 5: MessageBeep(MB_ICONHAND); end;
    If ShowEditFormOnStart then ButtonBearbeiten_OnClick(nil);
  end;
  Screen.Cursor:=crDefault;
end;

{-------------------------------------------------------------------------------
OnResize
-------------------------------------------------------------------------------}

procedure TMainForm.MainPanel_OnResize(Sender: TObject);
begin
  If (Assigned(ButtonForm))and(ButtonForm.Visible) then ButtonForm.SetBounds(1,1,MainPanel.Width-2,MainPanel.Height-2) else
  If (Assigned(ListForm))and(ListForm.Visible) then With ListForm do begin
    SetBounds(1,1,MainForm.MainPanel.Width-2,MainForm.MainPanel.Height-2);
    If ViewStyle=1 then begin

      {<-> Die Spaltenbreite wird derzeit leider bei der vsList-Darstellung nicht wie gewollt gesetzt, mu noch ausgebessert werden !}
      ListView.Columns[0].Width:=ColumnTextWidth; ListView.Columns[1].Width:=ColumnTextWidth;
            
    end else begin ListView.Columns[0].Width:=ListColumnwidthName; ListView.Columns[1].Width:=ListColumnwidthBefehl; end;
  end;
end;

procedure TMainForm.ButtonPanel_OnResize(Sender: TObject);
begin ButtonBeenden.Left:=Width-ButtonBeenden.Width-15; end;

{-------------------------------------------------------------------------------
OnClick
-------------------------------------------------------------------------------}

procedure TMainForm.ButtonBearbeiten_OnClick(Sender: TObject);
begin With TEditForm.Create(Self) do Try ShowModal; Finally Free; end; end;

procedure TMainForm.ButtonBeenden_OnClick(Sender: TObject);
begin Close; end;

{-------------------------------------------------------------------------------
Public
-------------------------------------------------------------------------------}

function TMainForm.FileIsReadOnly(FileCom: string): boolean;
var FIRO_TSR: TSearchRec;
begin
  If FindFirst(FileCom,faAnyFile,FIRO_TSR)=0 then Result:=(FIRO_TSR.Attr and faReadOnly > 0) else Result:=false;
  FindClose(FIRO_TSR);
end;

procedure TMainForm.SetViewStyle(ViewStyleNr: integer);
begin
  Case ViewStyleNr of
    1..2: begin // Listenansicht (1=Liste oder 2=Details)
            If Assigned(ButtonForm) then ButtonForm.Hide;
            If not Assigned(ListForm) then begin Application.CreateForm(TListForm, ListForm); ListForm.Parent:=MainPanel; end;
            With ListForm do begin
              Case ViewStyleNr of 1: ListView.ViewStyle:=vsList; 2: ListView.ViewStyle:=vsReport; end;
              {$IFNDEF VER90} ListView.GridLines:=ListGridLines; ListView.HotTrack:=ShowHotTrack; {$ENDIF}
              
              {<-> Dieser wert gilt leider nur fr ViewStyle=vsLargeIcon oder ViewStyle=vsSmallIcon, mu noch ausgebessert werden !}
              ListView.IconOptions.WrapText:=ListWrapText; ListView.ShowColumnHeaders:=ListShowHeader;

              Show; BringToFront;
            end;
          end;
    else begin // Buttons
      If Assigned(ListForm) then ListForm.Hide;
      If not Assigned(ButtonForm) then begin Application.CreateForm(TButtonForm, ButtonForm); ButtonForm.Parent:=MainPanel; end;
      ButtonForm.Show; ButtonForm.BringToFront;
    end;
  end;
end;

procedure TMainForm.SetItems;
var b1: boolean; i1, i2: integer; s1, s2: string; Btn: TExtBitBtn; ListItem: TListItem;
    TmpImgHandle: uint; FileInfo1: TSHFileInfo;
  // Setzt Variable FileInfo: TSHFileInfo aus der angegebenen Datei bzw. dem Verzeichnis FileCom
  function GetFileInfo(FileCom: string): THandle;
  begin
    s1:=FileCom; If ExpandFileCom(s1,s2)=3 then If (not FileExists(s1))and(not DirectoryExists(s1)) then If (FileExists(s1))or(DirectoryExists(s1)) then s1:=s2;
    If ShowIcons=1 then i2:=SHGFI_SYSICONINDEX or SHGFI_ICON or SHGFI_SMALLICON else i2:=SHGFI_SYSICONINDEX or SHGFI_ICON or SHGFI_LARGEICON;
    FillChar(FileInfo1,SizeOf(TSHFileInfo),0);
    Result:=SHGetFileInfo(PChar(s1),0,FileInfo1,SizeOf(TSHFileInfo),i2);
  end;
begin
  Try Screen.Cursor:=crHourGlass; b1:=false;
    // Zuerst die alten Werte zurcksetzen/entfernen, soll heien sicherheisthalber alles entfernen
    If (Assigned(ButtonForm))and(ButtonForm.Visible) then With ButtonForm.ScrollBox do begin
      For i1:=ControlCount-1 downto 0 do If Controls[i1] is TButton then begin Btn:=(Controls[i1] as TExtBitBtn); Btn.Hide; Btn.Free; end; end;
    If (Assigned(ListForm))and(ListForm.Visible) then With ListForm.ListView do begin StateImages:=nil;
      Items.Clear; If Selected<>nil then Selected.Delete; end;
    // Nun die neuen Eintrge (um-)setzen
    For i1:=0 to ItemLst.Count-1 do begin i2:=Pos('=',ItemLst[i1]); If i2>0 then begin
      s1:=copy(ItemLst[i1],1,i2-1); s2:=copy(ItemLst[i1],i2+1,Length(ItemLst[i1])-i2);
      If (Assigned(ButtonForm))and(ButtonForm.Visible) then With ButtonForm do begin
        Btn:=TExtBitBtn.Create(Self); Btn.Parent:=ScrollBox; Btn.Caption:=s1; Btn.Hint:=s2; {Btn.ShowHint:=true;}
        Btn.SetBounds(BtnLeft,i1*(BtnHeight+BtnDistance)+BtnTop,ScrollBox.ClientWidth-(BtnLeft*2),BtnHeight);
        Btn.OnClick:=ButtonForm.ButtonOnClick; Btn.Show;
        If i1=SelectedItem then begin MainForm.ActiveControl:=Btn; b1:=true; end;
      end;
      If (Assigned(ListForm))and(ListForm.Visible) then With ListForm.ListView do begin
        ListItem:=Items.Add; ListItem.Caption:=s1; ListItem.SubItems.Add(s2);
        If i1=SelectedItem then begin Selected:=Items[i1]; b1:=true; end;
      end;
    end; end;
    Update;
    // Jetzt noch die (Shell-)Images anzeigen
    If (ShowIcons=1)or(ShowIcons=2) then begin
      If (Assigned(ButtonForm))and(ButtonForm.Visible) then With ButtonForm.ScrollBox do begin
        For i1:=0 to ControlCount-1 do If Controls[i1] is TBitBtn then With (Controls[i1] as TBitBtn) do begin
          ImageList.Handle:=GetFileInfo(Hint);
          ImageList.GetBitmap(FileInfo1.iIcon,Glyph); Spacing:=BtnIconsDistance;
          Case BtnIconsLayout of 1: Layout:=blGlyphRight; 2: Layout:=blGlyphTop; 3: Layout:=blGlyphBottom; else Layout:=blGlyphLeft; end;
        end;
      end;
      If (Assigned(ListForm))and(ListForm.Visible) then With ListForm.ListView do begin
        If ShowIcons=1 then i2:=SHGFI_SMALLICON else i2:=SHGFI_LARGEICON;
        TmpImgHandle:=ShGetFileInfo('',0,FileInfo1,SizeOf(FileInfo1),shgfi_SysIconIndex or i2);
        If TmpImgHandle<>0 then begin
          MainForm.ImageList.Handle:=TmpImgHandle;
          SmallImages:=MainForm.ImageList;
          For i1:=0 to pred(Items.Count) do begin
            s1:=Items[i1].SubItems[0];
            If ExpandFileCom(s1,s2)>0 then begin
              ShGetFileInfo(PChar(s1),0,FileInfo1,SizeOf(FileInfo1),shgfi_SysIconIndex or shgfi_Icon or i2 or shgfi_typename);
              Items[i1].ImageIndex:=FileInfo1.iIcon;
            end;
          end;
        end;
      end;
    end;
    // und weitere Nachbereitungen
    If (b1)and(Assigned(ListForm))and(ListForm.Visible) then ActiveControl:=ListForm.ListView else
    If not b1 then ActiveControl:=ButtonBeenden;
  Finally Screen.Cursor:=crDefault; end;
end;

// Setzt entsprechend der String-Variablen KommentarTextDatei das Kommentarfeld. Soll heissen, Memo wird entweder
// angezeigt oder jedoch ausgeblendet. Die Kommentarfeldhhe wird selbstverstndlich auch aktualisiert.
procedure TMainForm.SetKommentarMemo;
var s1, s2: string;
begin
  s1:=KommentarTextDatei;
  If ExpandFileCom(s1,s2)=1 then begin
    Memo.Clear; Memo.Height:=KommentarFeldHight; Memo.Visible:=true; Splitter.Height:=3; // Memo einblenden
    Memo.Lines.LoadFromFile(s1); // nun noch Textdatei in Memo einlesen
  end else If Memo.Visible then begin Memo.Visible:=false; Splitter.Height:=0; end;
end;

// Zeigt/Versteckt die Statuszeile und richtet den Text aus (Angaben werden gem. den Variablen Statusbar_Show & Statusbar_Alignment gesetzt)
procedure TMainForm.SetStatusbarShowState;
begin
  If Statusbar_Show then begin
    Case StatusBar_Alignment of 1: Statusbar.Alignment:=taCenter; 2: Statusbar.Alignment:=taRightJustify; else Statusbar.Alignment:=taLeftJustify; end;
    Application.OnHint:=ShowHints; StatusbarMain.Visible:=true;
  end else begin Application.OnHint:=nil; StatusbarMain.Visible:=false; end;
end;

// Erweitert einen unvollstndig angegebene Datei-/Verzeichnis-/Parameterangabe
// bergeben wird in FileCom entsprechend der Befehl und in Parameter nichts. Zurckgeliefert
// wird dann in FileCom die volle Befehlszeile und in Parameter die Parameterangaben (natrlich
// vorausgesetzt diese konnten erweitert werden)
// Rckgabewerte (Result) sind:
//   0 = Fehler: Angabe keine Datei-/Verzeichnis-/Parameterangabe, unbekannt !
//   1 = Erfolgreich: Datei gefunden
//   2 = Erfolgreich: Verzeichnis gefunden
//   3 = Erfolgreich: Eventuelle Parameterangabe gefunden (wird in "var Parameter: string" zurckgeliefert)
function TMainForm.ExpandFileCom(var FileCom: string; var Parameter: string): integer;
var i1: integer; s1, s2, s3: string;
begin
  Result:=0; Parameter:=''; s1:=Trim(FileCom); If s1='' then Exit else If s1[1]='\' then Delete(s1,1,1);
  If FileExists(s1) then begin Result:=1; FileCom:=ExpandFileName(s1); end else
  If DirectoryExists(s1) then begin Result:=2; FileCom:=ExpandFileName(s1) end else
  If FileExists(ExtractFilePath(ParamStr(0))+s1) then begin Result:=1; FileCom:=ExtractFilePath(ParamStr(0))+s1; end else
  If DirectoryExists(ExtractFilePath(ParamStr(0))+s1) then begin Result:=2; FileCom:=ExtractFilePath(ParamStr(0))+s1; end else
  If FileExists(ParamStr(0)[1]+':\'+s1) then begin Result:=1; FileCom:=ParamStr(0)[1]+':\'+s1 end else
  If DirectoryExists(ParamStr(0)[1]+':\'+s1) then begin Result:=2; FileCom:=ParamStr(0)[1]+':\'+s1 end else begin
    i1:=Pos('|',s1); If i1<1 then Result:=0 else begin
    s2:=copy(s1,1,i1); If s2>'' then begin If s2[Length(s2)]='|' then Delete(s2,Length(s2),1); ExpandFileCom(s2,s3); end;
    Delete(s1,1,i1); If s1>'' then begin If s1[1]='|' then Delete(s1,1,1); ExpandFileCom(s1,s3); end;
    FileCom:=s2; Parameter:=s1; Result:=3;
  end; end;
end;

// Fhrt einen Befehl aus (Datei oder Verzeichnis)
// ExecuteStr enthlt dabei sowohl die eigentliche Befehlszeile als auch die Kommandozeilenparameter (um sicherzugehen das diese auch voneinander getrennt dient "|" als Trennzeichen)
procedure TMainForm.ExecuteCom(ExecuteStr: string; ShowState: integer; UseAfterExecute, ShowErrorMsg: boolean);
var b1: boolean; s1: string; i1: THandle; sei: TShellExecuteInfo;
begin
  s1:=''; i1:=MainForm.ExpandFileCom(ExecuteStr,s1);
  With sei do begin
    FillChar(sei,SizeOf(sei),0);
    cbSize:=SizeOf(sei);
    fMask:=SEE_MASK_NOCLOSEPROCESS or SEE_MASK_FLAG_DDEWAIT or SEE_MASK_FLAG_NO_UI;
    lpFile:=PChar(ExecuteStr);
    lpDirectory:=PChar(ExtractFilePath(ExecuteStr));
    lpParameters:=PChar(s1);
    nShow:=ShowState;
  end;
  If not ShellExecuteEx(@sei) then If ShowErrorMsg then begin
    Case sei.hInstApp of
      0: s1:='Nicht gengend freier Speicher bzw. freie Resourcen.';
      ERROR_FILE_NOT_FOUND: s1:='Datei konnte nicht gefunden werden.';
      ERROR_PATH_NOT_FOUND: s1:='Verzeichnis konnte nicht gefunden werden.';
      ERROR_BAD_FORMAT: s1:='Die EXE-Datei ist fehlerhaft oder ungltig.';
      SE_ERR_ACCESSDENIED: s1:='Das Betriebssystem hat keinen Zugriff auf die spezifizierte Datei.';
      SE_ERR_ASSOCINCOMPLETE: s1:='Der angegebene Dateiname ist ungltig oder unkomplet.';
      SE_ERR_DDEBUSY: s1:='DDE-Konversation fehlgeschlagen, da z.Z. eine andere DDE-Transaktion aktiv ist.';
      SE_ERR_DDEFAIL: s1:='DDE-Konversation fehlgeschlagen.';
      SE_ERR_DDETIMEOUT: s1:='DDE-Konversation schlug fehl, da zugestandene Zeit berschritten wurde.';
      SE_ERR_DLLNOTFOUND: s1:='Die spezifizierte Dynamik-Link-Library konnte nicht gefunden werden.';
      SE_ERR_NOASSOC: s1:='Dieser Dateierweiterung ist kein Programm zugeordnet.';
      SE_ERR_OOM: s1:='Nicht gengend freier Speicher um die Operation durchzufhren.';
      SE_ERR_SHARE: s1:='Windows-Schutzverletzung.';
      else s1:='Unbekannter Fehler. Aktion konnte nicht durchgefhrt werden.';
    end;
    MessageBox(0,PChar(s1),'Fehler: Ausfhrung fehlgeschlagen...',MB_IconStop+MB_Ok+MB_SetForeground+MB_ApplModal);
    Exit;
  end;
  If UseAfterExecute then Case AfterExecute of
    1: If not DirectoryExists(ExecuteStr) then begin
         ZoomMinimized; Sleep(500);
         Repeat Application.ProcessMessages; b1:=GetExitCodeProcess(sei.hProcess,i1); until (not b1)or(Application.Terminated)or(i1<>STILL_ACTIVE)or(not IsMinimized);
         If (IsMinimized)and(not Application.Terminated) then ZoomRestore;
       end;
    2: ZoomMinimized;

       {<-> BUG: Aus unbekanntem Grunde wird die folgende MessageBox nicht MB_APPLMODAL angezeigt !}
    3: If MessageBox(0,'Soll Autorun wirklich beendet werden ?','Beenden',MB_IconQuestion+MB_OkCancel+MB_SetForeground+MB_ApplModal)=idOk then Close;

    4: Close;
  end;
end;

function BoolToInteger(BoolWert: boolean): integer;
begin If BoolWert then Result:=1 else Result:=0; end;

{-------------------------------------------------------------------------------
Private
-------------------------------------------------------------------------------}

procedure TMainForm.WMSysCommand(var Message: TMessage);
begin Case Message.WParam of SC_MINIMIZE: ZoomMinimized; else inherited; end; end;

procedure TMainForm.ZoomMinimized;
begin
  IsMinimized:=true; Application.Title:=MainForm.Caption; Application.NormalizeTopMosts; SetActiveWindow(Application.Handle);
  SetWindowPos(Application.Handle,HWND_BOTTOM,Left,Top,Width,0,SWP_NOACTIVATE); ShowWindow(Application.Handle,SW_MINIMIZE); Application.Title:=AppTitle;
end;

procedure TMainForm.ZoomRestore;
begin
  IsMinimized:=false; Application.Title:=MainForm.Caption; SetActiveWindow(Application.Handle); ShowWindow(Application.Handle,SW_RESTORE);
  SetWindowPos(Application.Handle,HWND_TOP,Screen.Width div 2,Screen.Height div 2,0,0,SWP_NOZORDER); Application.RestoreTopMosts; Application.Title:=AppTitle;
end;

procedure TMainForm.AppMessage(var Msg: TMsg; var Erledigt: Boolean);
begin
  Case Msg.Message of WM_SYSCOMMAND: Case Msg.WParam of
    SC_RESTORE: begin ZoomRestore; Erledigt:=true; end;
    SC_MINIMIZE: begin ZoomMinimized; Erledigt:=true; end;
  end; end;
end;

procedure TMainForm.ShowHints(Sender: TObject);
begin StatusBar.Caption:=Application.Hint; end;

END.
